<style>
  .config-time-count {
    width: 40px !important;
  }
</style>
<script type="text/html" data-template-name='camera-configuration'>
    <div class="form-row">
      <label for="node-input-broker"><i class="fa fa-globe"></i><span data-i18n="mqtt.label.broker"></span></label>
      <input type="text" id="node-input-broker">
    </div>
    <div class="form-row">
      <label for="node-input-name"><i class="fa fa-tag"></i><span data-i18n="common.label.name"></span></label>
      <input type="text" id="node-input-name" data-i18n="[placeholder]common.label.name">
    </div>
    <div class="form-row">
        <label for="node-input-detect"><i class="fa fa-search"></i><span data-i18n="camera-configuration.face-detection"></span></label>
        <input type="checkbox" id="node-input-detect" style="display:inline-block; width:auto; vertical-align:top;">
    </div>
    <div class="form-row">
        <label for="node-input-interval"><i class="fa fa-clock-o"></i><span data-i18n="camera-configuration.interval"></span></label>
        <input id="node-input-interval" class="config-time-count" value="1">
        <span data-i18n="camera-configuration.seconds"></span>
    </div>
    <div class="form-row">      
      <label for="node-input-camId"><i class="fa fa-tag"></i><span data-i18n="camera-configuration.cam-id"></span></label>
      <select id="node-input-camId" style="width:125px !important" required>
                <option value="" data-i18n="camera-configuration.choose-cam-id"></option>
      </select>
    </div>
</script>

<script type="text/javascript">
  var updateMsg = function (msg, needChange) {
    const label = this.name || "camera configuration";
    var node = this;
    $.ajax({
      url: `camera-configuration/${this.id}/${this.active ? 'enable' : 'disable'}`,
      type: "POST",
      data: { msg: JSON.stringify(msg) },
      success: function (resp, textStatus, xhr) {

        const historyEvent = {
          t: 'edit',
          node: node,
          changes: {
            active: !node.active,
          },
          dirty: node.dirty,
          changed: node.changed
        };
        // node.changed = needChange;
        node.dirty = true;
        RED.nodes.dirty(true);
        RED.history.push(historyEvent);
        RED.view.redraw();
        if (xhr.status == 200) {
          // if (needChange) {
          //   return RED.notify(RED._("notification.warning", { message: RED._("notification.warnings.undeployedChanges") }), "warning");
          // }Successfully
          // TODO i18n
          RED.notify("Successfully " + resp + ": " + label, "success");
        }
      },
      error: function (jqXHR, textStatus, errorThrown) {
        var message;

        switch (jqXHR.status) {
          case 404:
            message = "node not deployed";
            break;
          case 0:
            message = "no response from server";
            break;
          default:
            message = `unexpected error (${textStatus}) ${errorThrown}`;
        }
        // TODO i18n
        RED.notify(`<strong>Error</strong>: ${message}`, "error");
      }
    });
  }

  RED.nodes.registerType('camera-configuration', {
    category: 'nilvana',
    defaults: {
      camId: { value: "", required: true },
      name: {
        value: ""
      },
      interval: {
        value: 1,
        required: true,
        validate: RED.validators.number()
      },
      rtsppath: {
        value: "",
        required: true,
        validate: RED.validators.regex(/^(#$|(\+|[^+#]*)(\/(\+|[^+#]*))*(\/(\+|#|[^+#]*))?$)/)
      },
      detect: { value: true },
      topic: {
        value: "face/config",
        required: true,
        validate: RED.validators.regex(/^(#$|(\+|[^+#]*)(\/(\+|[^+#]*))*(\/(\+|#|[^+#]*))?$)/)
      },
      qos: {
        value: "1"
      },
      broker: {
        // node-red core
        type: "mqtt-broker",
        required: true
      },
      active: {
        value: false
      },
      hasCameras: {
        value: false
      },
      cameraSelected: {
        value: false
      }
    },
    color: "#D0AAE9",
    inputs: 0,
    outputs: 0,
    icon: "icons/icon-nodes-deamon.png",
    //   https://nodered.org/docs/creating-nodes/appearance#buttons
    button: {
      toggle: "active",
      // enabled: function() {
      // // return whether or not the button is enabled, based on the current
      // // configuration of the node
      //     return !this.changed
      // },
      visible: function () {
        // return whether or not the button is visible, based on the current
        // configuration of the node
        return !this.changed && this.hasCameras && this.cameraSelected
      },
      onclick: function () {        
        let node = this
        let cam_id = this.camId
        if (isNaN(this.interval)) {
          // TODO i18n
          return RED.notify(`<strong>Error</strong>: input interval is not a number`, "error");
        }
        if (cam_id === "") {
          // TODO i18n
          return RED.notify(`<strong>Error</strong>: please set camera id`, "error");
        }

        $.ajax({
        url: `set-cameras/${node.id}/${cam_id}`,
        method: 'GET',
        dataType: "json",
        contentType: "application/json",
        success: function (data) {
          if (data.rtsp_path === undefined) {
            // TODO i18n
            RED.notify(`<strong>Error</strong>: open camera fail`, "error");
            return
          }
          node.rtsppath = data.rtsp_path

          var faceMsg = {
            enable: node.active,
            detect: node.detect,
            interval: Number(node.interval),
            rtsp_path: node.rtsppath
          }

          updateMsg.call(node, faceMsg, false)
        },
        error: function () {
          if (cam_id === "") {
            // TODO i18n
            RED.notify(`<strong>Error</strong>: please set camera id`, "error");
          } else {
            // TODO i18n
            RED.notify(`<strong>Error</strong>: media server no response`, "error");
          }
        }
      });
      }
    },
    //   https://nodered.org/docs/creating-nodes/appearance#labels
    label: function () {
      return this.name || "camera configuration"
    },

    labelStyle: function () {
      return this.name ? "node_label_italic" : "";
    },
    oneditprepare: function () {
      var node = this;
      if (this.qos === undefined) {
        $("#node-input-qos").val("1");
      }
      $(".config-time-count").spinner({
        //max:60,
        min: 0
      });

      $.ajax({
        url: `get-cameras/${node.id}`,
        method: 'GET',
        dataType: "json",
        contentType: "application/json",
        success: function (data) {
          var cameras = data['cameras']

          if (!cameras) {
            node.hasCameras = false;
            // TODO i18n
            RED.notify(`<strong>Error</strong>: please plugin a camera.`, "error");
            return
          } else {
            node.hasCameras = true;
          }

          for (var i = 0; i < cameras.length; i++) // Assume list has all values fetched from db
          {
            var camera_id = cameras[i].id;
            var camera_port_type = cameras[i].port_type;
            var newOption = $('<option value="' + camera_id + '">' + camera_id + " " + camera_port_type + '</option>'); // Add all values to the dropdown list
            $("#node-input-camId").append(newOption);
          }

          if (node.camId != null && node.camId != '') {
            $("#node-input-camId").val(node.camId);
          }
        },
        error: function () {
          // TODO i18n
          RED.notify(`<strong>Error</strong>: please check media-sever is health.`, "error");
          return
        }
      });
    },
    oneditsave: function () {
      var interval = $("#node-input-interval").val();
      var detect = $("#node-input-detect").is(":checked")
      var cam_id = $("#node-input-camId").val();
      var node = this;
      if (isNaN(interval)) {
        // TODO i18n
        RED.notify(`<strong>Error</strong>: input interval is not a number`, "error");
        return
      }
      if (cam_id === "") {
        node.cameraSelected = false
        return RED.notify(`<strong>Error</strong>: please set camera id`, "error");
        return
      }
      node.cameraSelected = true      

      $.ajax({
        url: `set-cameras/${node.id}/${cam_id}`,
        method: 'GET',
        dataType: "json",
        contentType: "application/json",
        success: function (data) {
          if (data.rtsp_path === undefined) {
            // TODO i18n
            RED.notify(`<strong>Error</strong>: open camera fail`, "error");
            return
          }
          node.rtsppath = data.rtsp_path

          var faceMsg = {
            enable: node.active,
            detect: detect,
            interval: Number(interval),
            rtsp_path: node.rtsppath
          }
          updateMsg.call(node, faceMsg, false)
        },
        error: function () {
          if (cam_id === "") {
            // TODO i18n
            RED.notify(`<strong>Error</strong>: please set camera id`, "error");
          } else {
            // TODO i18n
            RED.notify(`<strong>Error</strong>: media server no response`, "error");
          }
        }
      });
    },
    oneditdelete: function () {
      // stop face detection
      console.log("oneditdelete")
      let faceMsg = {
        enable: false,
        detect: this.detect,
        interval: Number(this.interval),
        rtsp_path: this.rtsppath
      }
      updateMsg.call(this, faceMsg, false)
    }
  });

</script>